/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import type { ConnectionMode, IClientDetails, ISentSignalMessage } from "@fluidframework/protocol-definitions";
import { NetworkError } from "@fluidframework/server-services-client";
import type { ILogger } from "@fluidframework/server-services-core";
import type { IRoom } from "./interfaces";
export declare const getMessageMetadata: (documentId: string, tenantId: string, correlationId?: string) => {
    documentId: string;
    tenantId: string;
    correlationId: string | undefined;
};
export declare function handleServerErrorAndConvertToNetworkError(logger: ILogger, errorMessage: string, documentId: string, tenantId: string, error: unknown): NetworkError;
export declare class ExpirationTimer {
    private readonly onTimeout;
    private timer;
    constructor(onTimeout: () => void);
    clear(): void;
    set(mSecUntilExpiration: number): void;
}
export declare const hasWriteAccess: (scopes: string[]) => boolean;
export declare const isWriter: (scopes: string[], mode: ConnectionMode) => boolean;
export declare const SummarizerClientType = "summarizer";
export declare const isSummarizer: (clientDetails: IClientDetails) => boolean;
export declare const getRoomId: (room: IRoom) => string;
export declare const getClientSpecificRoomId: (clientId: string) => string;
export declare function isSentSignalMessage(obj: unknown): obj is ISentSignalMessage;
//# sourceMappingURL=utils.d.ts.map